/*
 * 
 * 
 */

package autofeature.intermediate;

import autofeature.parser.RuleMatch;
import java.util.HashMap;
import java.util.Map;
import org.antlr.runtime.TokenStream;
import org.antlr.runtime.tree.CommonTree;

/**
 *
 * @author Hendrik Speidel - speidel@fmi.uni-passau.de
 */
public class AST {

    public final CommonTree root;
    public final Map<CommonTree, String> blocks;
    public final Map<CommonTree, RuleMatch> ruleMatches;
    public final TokenStream input;


    public AST(CommonTree t, Map<CommonTree, String> attachments, Map<CommonTree, RuleMatch> ruleMatches, TokenStream input) {
        this.root = t;
        this.blocks = attachments;
        this.ruleMatches = ruleMatches;
        this.input = input;
    }

    public AST asAst(CommonTree t) {
        return new AST(t, blocks, ruleMatches, input);
    }
}
