/*
 * 
 * 
 */

package autofeature.intermediate;

import java.util.Collection;
import java.util.Iterator;
import org.antlr.runtime.tree.CommonTree;

/**
 *
 * @author Hendrik Speidel - speidel@fmi.uni-passau.de
 */
public class TreeUtil {



    public static String joinChilds(CommonTree t) {
        return joinChilds(t, " ");
    }

    public static String joinChilds(CommonTree t, String joinWith) {
        
        return joinChilds(t, 0, t.getChildCount());
    }

    public static String joinChilds(CommonTree t, int l, int r) {
        return joinChilds(t, l, r, " ");
    }

    public static String joinChilds(CommonTree t, int l, int r, String joinWith) {
        StringBuffer buf = new StringBuffer();
        buf.append(t.getChild(l).getText());
        for (int i = l + 1; i < r; i++) {
            buf.append(joinWith);
            buf.append(t.getChild(i));
        }
        return buf.toString();
    }

    public static ChildIterable childs(CommonTree t, int l, int r) {
        return new ChildIterable(t, l, r);
    }

    public static ChildIterable childs(CommonTree t, int l) {
        return new ChildIterable(t, l, t.getChildCount());
    }

    public static ChildIterable childs(CommonTree t) {
        return new ChildIterable(t, 0, t.getChildCount());
    }

    public static class ChildIterable implements Iterable<CommonTree> {
        private final CommonTree data;
        private final int r;
        private final int l;

        private ChildIterable(CommonTree t, int l, int r) {
            this.data=t;
            this.l = l;
            this.r = r;
        }

        public Iterator<CommonTree> iterator() {
            return new ChildIterator<CommonTree>(data, l, r);
        }

    }

    public static class ChildIterator<T> implements Iterator<CommonTree> {
        private final CommonTree tree;
        private int cur;
        private final int r;
        private ChildIterator(CommonTree tree, int l ,int r) {
            this.tree = tree;
            this.cur = l;
            this.r = r;
        }

        public boolean hasNext() {
            return cur < Math.min(tree.getChildCount(), r);
        }

        public CommonTree next() {
            CommonTree res = (CommonTree) tree.getChild(cur);
            cur++;
            return res;
        }

        public void remove() {
            throw new UnsupportedOperationException("Remove not supported!");
        }
    }
}
