/*
 * 
 * 
 */

package autofeature.parser;

import java.util.ArrayList;
import java.util.List;
import org.antlr.runtime.CommonToken;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.TokenStream;

/**
 *
 * @author Hendrik Speidel - speidel@fmi.uni-passau.de
 */
public class RuleMatch {

    private final TokenStream input;

    public final List<SubRuleMatch> subs;
    public final int left;
    public final int right;

    public RuleMatch(TokenStream input, int left, int right, List<SubRuleMatch> rewrites) {
        this.input = input;
        this.subs = rewrites;
        this.left = left;
        this.right = right;
    }

    @Override
    public String toString() {

        int l = left - 1;

        while (true) {
            CommonToken t = (CommonToken) input.get(l);
            if (t == null || t.getChannel() != CommonToken.HIDDEN_CHANNEL) {
                break;
            } else {
                l--;
            }
        }

        int size = input.size();
        int r = right + 1;

        while (r < size && input.get(r).getChannel() == CommonToken.HIDDEN_CHANNEL) {
            r++;
        }

        return input.toString(l + 1, r - 1);
        
    }

    public String toString(Rewriter r) {
        StringBuffer buf = new StringBuffer();
        int pos = left;
        for (SubRuleMatch op : subs) {
            if (pos < op.left) {
                buf.append(input.toString(pos, op.left));
            }
            buf.append(r.visit(op));
            pos = op.right;
        }
        if (pos < right) {
            buf.append(input.toString(pos, right));
        }
        return buf.toString();
    }
    
}
