/*
 * 
 * 
 */

package autofeature.parser;

import autofeature.intermediate.AST;
import autofeature.intermediate.Specification;
import java.io.IOException;
import org.antlr.runtime.ANTLRFileStream;
import org.antlr.runtime.ANTLRStringStream;
import org.antlr.runtime.CharStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.tree.CommonTree;

/**
 *
 * @author Hendrik Speidel - speidel@fmi.uni-passau.de
 */
public class SpecificationReader {

    public Specification readString(String specificationStr) throws RecognitionException {
        CharStream input = new ANTLRStringStream(specificationStr);
        return doRead(input);
    }

    public Specification readFile(String filename) throws IOException, RecognitionException {
        CharStream input = new ANTLRFileStream(filename, "UTF8");
        return doRead(input);
    }

    private Specification doRead(CharStream input) throws RecognitionException {

        WslLexer lexer = new WslLexer(input);
        CommonTokenStream tokens = new CommonTokenStream(lexer);
        WslParser parser = new WslParser(tokens);
        WslParser.spec_return spec = parser.spec();
        CommonTree t = (CommonTree) spec.getTree();
        //System.out.println("HAHAHAA:" + parser.input.toString(0, 3));
        //System.out.println("HAHAHAA:" + parser.input.toString(2, 5));
        AST ast = new AST(t, parser.getAttachments(), parser.getRuleMatches(), parser.input);

        return new Specification(ast);
    }

}
