#include "Email.h"
#include "Client.h"

automaton EncryptConsistently3 {

    introduction {
        shadow struct email {
            int mail_is_sensitive;
        };
    }

    before void init_email(msg:struct email*) {
        printf("before init\n");
        msg->mail_is_sensitive = -1;
        printf("msg->mail_is_sensitive: %d\n", msg->mail_is_sensitive);
    }

    after clone = struct email* cloneEmail(msg:struct email*) {
        printf("after clone\n");
        clone->mail_is_sensitive = msg->mail_is_sensitive;
        printf("msg->mail_is_sensitive: %d\n", msg->mail_is_sensitive);
        printf("clone->mail_is_sensitive: %d\n", clone->mail_is_sensitive);
    }

    before void mail(_:struct client*, msg:struct email*) {
        printf("before mail\n");
        printf("mail_is_sensitive: %d\n", msg->mail_is_sensitive);
        if (msg->mail_is_sensitive == -1) {
            msg->mail_is_sensitive = isEncrypted(msg);
        } else if (msg->mail_is_sensitive != isEncrypted(msg)) {
            fail;
        }
    }

}
