# 1 "./GlobalVar_spec.c"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "./GlobalVar_spec.c"

struct JoinPoint {
 void** (*fp) (struct JoinPoint *);
 void ** args;
 int argsCount;
 const char ** argsType;
  void * (*arg)(int, struct JoinPoint *);
  const char * (*argType)(int , struct JoinPoint *);
 void ** retValue;
 const char * retType;
 const char * funcName ;
 const char * targetName ;
 const char * fileName ;
 const char * kind ;
 void * excep_return ;
};

 struct __UTAC__EXCEPTION {
 void * jumpbuf ;
 unsigned long long int prtValue ;
 int pops;
 struct __UTAC__CFLOW_FUNC {
  int (*func)(int,int) ;
  int val ;
  struct __UTAC__CFLOW_FUNC * next;
 } * cflowfuncs;
};

extern void __utac__exception__cf_handler_set(void * exception, int (*cflow_func)(int, int), int val) ;
extern void __utac__exception__cf_handler_free(void * exception);
extern void __utac__exception__cf_handler_reset(void * exception) ;
extern void * __utac__error_stack_mgt(void * env , int mode, int count) ;

# 1 "./Email.h" 1





struct email {
  int id;
  char *from;
  char *to;
  char *subject;
  char *body;
  int isEncrypted;
  char *encryptionKey;};


struct email *cloneEmail (struct email *msg);


void printMail (struct email *msg);


int isReadable (struct email *msg);


int isEncrypted (struct email *msg);
# 35 "./GlobalVar_spec.c" 2

# 1 "./Client.h" 1






# 1 "./slist.h" 1





typedef struct node_s
{
  void *data;
  struct node_s *next;
} NODE;



NODE *list_create (void *data);


NODE *list_insert_after (NODE * node, void *data);


NODE *list_insert_beginning (NODE * list, void *data);


int list_remove (NODE * list, NODE * node);


int list_foreach (NODE * node, int (*func) (void *));


NODE *list_find (NODE * node, int (*func) (void *, void *), void *data);
# 8 "./Client.h" 2
struct client {
  char *name;
  NODE *outgoingBuffer;
  NODE *userPublicKeyPairs;
  char *privateKey;
  NODE *addressBook;
  int idCounter;};


void outgoing (struct client *client, struct email *msg);


void incoming (struct client *client, struct email *msg);
struct userPublicKeyPair {
  char *user;
  char *publicKey;};


int isKeyPairValid (char *publicKey, char *privateKey);

void encrypt (struct client *client, struct email *msg);
struct addressBookEntry {
  char *alias;
  NODE *address;};



void resolveAlias (struct client *client, struct email *msg);

void decrypt (struct client *client, struct email *msg);


void addMessageID (struct client *client, struct email *msg);
# 37 "./GlobalVar_spec.c" 2
# 4 "GlobalVar_spec.acc"
int mail_is_sensitive = (-1);
# 8 "GlobalVar_spec.acc"
 inline __utac_acc__GlobalVar_spec__1(struct client *client, struct email *msg , struct JoinPoint * this ) {
# 16 "GlobalVar_spec.acc"
if (mail_is_sensitive == (-1)){
{
# 11 "GlobalVar_spec.acc"
mail_is_sensitive = isEncrypted(msg); } }else{
if (mail_is_sensitive != isEncrypted(msg)){
{
# 13 "GlobalVar_spec.acc"
printf("ERROR!! Safety property violated!!"); } }}
# 16 "GlobalVar_spec.acc"
(this->fp(this)); }
